#pragma once

#include <Base_DAQ_Observer.h>
#include <Astri_DAQ.h>

#include <mysql-cppconn/mysql/jdbc.h>

#include <atomic>
#include <thread>
#include <mutex>
#include <condition_variable>

namespace inaf::oasbo::DAQ_observers {
class AstriMySQLDAQObserver: public BaseDAQ_Observer {
protected:
	sql::mysql::MySQL_Driver *driver = nullptr;
	sql::Connection *con = nullptr;
	std::string ip { }, username { }, password { }, dbname { };
	int port;
	inaf::oasbo::DAQ::AstriDAQ *astri_daq;
	sql::PreparedStatement *stmt = nullptr;
	bool file_is_open;

	static const std::string FILES_TABLE;
	static const std::string CLOSED_FIELD;
	static const std::string CREATED_FIELD;
	static const std::string PATH_FIELD;
	static const std::string FILENAME_FIELD;
	static const std::string ID_FIELD;
	static const std::string DAQID_FIELD;
	static const std::string SCHED_BLOCK_FIELD;
	static const std::string SCHED_BLOCK_TABLE;
	static const std::string ACTIVE_FIELD;

public:
	AstriMySQLDAQObserver(inaf::oasbo::DAQ::BaseDAQ &dataAcquisition,std::string ip, int port, std::string username, std::string password, std::string dbname);
	~AstriMySQLDAQObserver();

	void updatePacketStats() override;
	void updateArchiverStats() override;
	void updateProviderStats() override;
	void updateReceiverStats() override;
	void updateAll() override;
	void start() override;
	void stop() override;
};
}
